/* $Id: linalg.h,v 3.1 1998/03/20 23:29:12 kas Exp $ */

/* Linear algebra macros */

/*
 *  Programs used in my diploma thesis.
 *  Copyright (C) 1995-1997  Jan "Yenya" Kasprzak <kas@fi.muni.cz>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef LINALG_H__
#define LINALG_H__ 1

#ifdef INLINE_FUNCTIONS
static REAL __inline__ compute_distance_sq(x, y, z, at1, at2)
REAL *x, *y, *z;
{
	return ((x[at1] - x[at2])*(x[at1] - x[at2])
		+ (y[at1] - y[at2])*(y[at1] - y[at2])
		+ (z[at1] - z[at2])*(z[at1] - z[at2]));
}
#else
extern REAL compute_distance_sq __P((REAL *x, REAL *y, REAL *z, int at1, int at2));
#endif

/* Difference of 3-dimensional vectors: */
#define vdiff3(dst, src1, src2) { (dst)[0] = (src1)[0]-(src2)[0]; \
	(dst)[1] = (src1)[1]-(src2)[1]; \
	(dst)[2] = (src1)[2]-(src2)[2]; }

/* Make vector from two atoms */
#define vectpts(v,x,y,z,a1,a2) { (v)[0] = (x)[(a1)]-(x)[(a2)]; \
	(v)[1] = (y)[(a1)]-(y)[(a2)]; \
	(v)[2] = (z)[(a1)]-(z)[(a2)]; }

/* Dot product of 3-dimensional vectors: */
#define dot3(x,y)	 ((x)[0]*(y)[0] + (x)[1]*(y)[1] + (x)[2]*(y)[2])

/* 2nd norm of a 3-dimensional vector: */
#define norm3(x)	(sqrt(dot3((x),(x))))

/* Crossproduct of 3-dimensional vectors: */
#define cross3(dst,src1,src2) { (dst)[0] = (src1)[1]*(src2)[2] - (src1)[2]*(src2)[1]; \
	(dst)[1] = (src1)[2]*(src2)[0] - (src1)[0]*(src2)[2]; \
	(dst)[2] = (src1)[0]*(src2)[1] - (src1)[1]*(src2)[0]; }

#define scalmul3(v, scal) (v)[0] *= (scal); (v)[1] *= (scal); (v)[2] *= (scal);
#endif /* LINALG_H__ */
